//xsetaseta@gmail.com
//
//PULSOV3_no serie
//Usar con GAMBAS Pulso Plotter V2
//
//___________

char clave[] = "PULSV3";

#include <Wire.h>
#include "MAX30105.h"           //MAX3010x library
#include "heartRate.h"          //Heart rate calculating algorithm

MAX30105 particleSensor;

const byte RATE_SIZE = 4; //Increase this for more averaging. 4 is good.
byte rates[RATE_SIZE]; //Array of heart rates
byte rateSpot = 0;
long lastBeat = 0; //Time at which the last beat occurred
float beatsPerMinute;
int beatAvg;

bool pulso;
long dato;

int z, z1;
long valorMin, valorMinT;

void setup()
{
  Serial.begin(115200);
  for(z=0;z<3;z++){  Serial.println(clave);  delay(200);}
    
  particleSensor.begin(Wire, I2C_SPEED_FAST); //Use default I2C port, 400kHz speed
  particleSensor.setup(); //Configure sensor with default settings
  particleSensor.setPulseAmplitudeRed(0x0A); //Turn Red LED to low to indicate sensor is running
  delay(1000);
}

void loop()
{

  //long irValue = particleSensor.getIR();    //Reading the IR value it will permit us to know if there's a finger on the sensor or not
  long irValue = particleSensor.getRed();

  //Also detecting a heartbeat
  if (irValue > 7000)
  { //If a finger is detected
    if (checkForBeat(irValue) == true)                        //If a heart beat is detected
    {
      pulso = 1;
      tone(9, 500);                                       //And tone the buzzer for a 100ms you can reduce it it will be better
      delay(100);
      noTone(9);                                          //Deactivate the buzzer to have the effect of a "bip"
      //We sensed a beat!
      long delta = millis() - lastBeat;                   //Measure duration between two beats
      lastBeat = millis();

      beatsPerMinute = 60 / (delta / 1000.0);           //Calculating the BPM

      if (beatsPerMinute < 255 && beatsPerMinute > 20)               //To calculate the average we strore some values (4) then do some math to calculate the average
      {
        rates[rateSpot++] = (byte)beatsPerMinute; //Store this reading in the array
        rateSpot %= RATE_SIZE; //Wrap variable

        //Take average of readings
        beatAvg = 0;
        for (byte x = 0 ; x < RATE_SIZE ; x++)
          beatAvg += rates[x];
        beatAvg /= RATE_SIZE;
      }
    }

  }
  if (irValue < 7000)
  { 
    beatAvg = 0;
    //  Serial.println("No detectado, Pon el dedo");
    noTone(9);
  }

  dato = irValue;

  dato = dato * -1;
  dato += 145000;

  z = dato - valorMinT;
  if (z > 2500)z = 2500;
  if (z < -500) z = -500;


  Serial.print(z);
  Serial.print(",");
  Serial.print(beatAvg);
  Serial.print(",");
  Serial.print(pulso);
  Serial.println("");
  pulso = 0;
  z1++;
  if (z1 > 20)
  {
    z1 = 0;
    valorMinT = (valorMin + valorMinT) / 2;
    valorMin = 300000;
  }
  if (dato < valorMin) valorMin = dato;

}
